import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["children", "activeTabIndex", "defaultActiveTabIndex", "onChange"];
import { Children, cloneElement } from 'react';
import PropTypes from 'prop-types';
import useControlledState from '@s-ui/react-hooks/lib/useControlledState';
import MoleculeTab from './components/MoleculeTab.js';
import MoleculeTabs from './components/MoleculeTabs.js';
import { TYPES, VARIANTS } from './config.js';
import { jsx as _jsx } from "react/jsx-runtime";
var MoleculeTabsWithStateActive = function MoleculeTabsWithStateActive(_ref) {
  var children = _ref.children,
    activeTabIndexProp = _ref.activeTabIndex,
    _ref$defaultActiveTab = _ref.defaultActiveTabIndex,
    defaultActiveTabIndexProp = _ref$defaultActiveTab === void 0 ? 1 : _ref$defaultActiveTab,
    onChange = _ref.onChange,
    props = _objectWithoutPropertiesLoose(_ref, _excluded);
  var _useControlledState = useControlledState(activeTabIndexProp, defaultActiveTabIndexProp),
    activeTab = _useControlledState[0],
    setActiveTab = _useControlledState[1];
  var handleChange = function handleChange(e, _ref2) {
    var tabIndex = _ref2.numTab;
    setActiveTab(tabIndex);
    typeof onChange === 'function' && onChange(e, {
      numTab: tabIndex
    });
  };
  return /*#__PURE__*/_jsx(MoleculeTabs, _extends({}, props, {
    onChange: handleChange,
    children: Children.toArray(children).filter(Boolean).map(function (child, index) {
      return /*#__PURE__*/cloneElement(child, {
        active: activeTab === index + 1
      });
    })
  }));
};
MoleculeTabsWithStateActive.displayName = 'MoleculeTabsWithStateActive';
export { MoleculeTab, MoleculeTabs, MoleculeTabsWithStateActive, TYPES as moleculeTabsTypes, VARIANTS as moleculeTabsVariants };
export default MoleculeTabsWithStateActive;